package inria.meije.rc.demos.reflexgame.basic;

import java.awt.*;
import java.rmi.*;
import inria.meije.rc.sugarcubes.*;
import inria.meije.rc.io.*;

public class Main extends Frame
{
    Button ready = new Button("READY");
    Button stop  = new Button("STOP");

    static EventMachine machine = new EventMachine();

    public Main(String name){
        super(name);
        setLayout(new GridLayout(0,1));
        add(stop); add(ready);
        pack();
        show();
    }

    public boolean handleEvent(java.awt.Event evt){
        if (evt.id == java.awt.Event.WINDOW_DESTROY) System.exit(0);
        if (evt.target == stop){ machine.add(new Generate("stop")); }
        else if (evt.target == ready){ machine.add(new Generate("ready")); }
        return true;
    }

    public static void main(String[] argv){
        Main g = new Main("Reflex Game");
        Counter counter=new Counter();
        Instruction avaitReady =
            new Seq(new PrintAtom("Press READY to start!\n"),new Seq(new JavaAtom(new AwaitColors(g.ready,g.stop)),new Await("ready")));
        Instruction randAwait =
            new Until("stop",
                      new Seq(new PrintAtom("Wait...\n"),new RandomRepeat(new Stop())),
                      new Seq(new Generate("cheating"),new Stop()));
        Instruction awaitStop =
            new Seq(new PrintAtom("Press STOP to terminate!\n"),
                    new Until("stop",
                              new Seq(new JavaAtom(new AwaitColors(g.stop,g.ready)),new Loop(new Seq(new JavaAtom(new IncrementCounter()),new Stop()))),
                              new JavaAtom(new PrintCounterValue())));
        Instruction measure =
            new Seq(avaitReady,new Seq(randAwait,awaitStop));
        Instruction measureList =
            new Until("cheating",
                      new Seq(new Repeat(4,measure),
                              new JavaAtom(new PrintCounterAverage())),
                      new Seq(new PrintAtom("You are cheating!\n"),new Stop()));
       Instruction game =
           new Until("tooManyCheats",new Merge(new Seq(new Repeat(3,new Seq(new Await("cheating"),new Stop())),new Generate("tooManyCheats"))
                                   ,new Loop(new Seq(new PrintAtom("New game begins!\n"),measureList)))
                                               ,new Seq(new PrintAtom("You are cheating too much Bye!\n"),new JavaAtom( new ExitGame())));
       machine.add(new Cube("counter",counter,game));
        while (true){
            machine.react();
            System.out.flush();
            Thread.yield();
        }
    }
}
